#include <bits/stdc++.h>
    using namespace std;

    int n,k;
    int a[500005];
    bool b[500005];

    int main()
    {
        scanf("%d%d",&n,&k);
        for(int i=0; i<n; i++)
            scanf("%d",a+i);
        a[n]=-1;
        int lw=0,rw=k;
        while(true)
        {
            bool sortiran=true;
            for(int i=lw; i<rw; i++)
                if(a[i]>a[i+1])
                    sortiran=false;

            if(sortiran)
            {
                while(a[rw]<=a[rw+1])
                    lw++,rw++;
                for(int i=rw; i>lw; i--)
                    b[i]=true;
                break;
            }

            else
            {
                int mini=2000000005;
                int minind=lw;
                for(int i=lw; i<=rw; i++)
                {
                    if(a[i]<mini)
                    {
                        mini=a[i];
                        minind=i;
                    }
                }
                for(int i=lw; i<minind; i++)
                {
                    b[i]=true;
                    k--;
                }
                lw=minind+1;
                rw=minind+1+k;
                if(k==0) break;
            }

        }
        for(int i=0; i<n; i++)
        {
            if(!b[i])
                printf("%d ",a[i]);
        }
        return 0;
    }